"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
var uuid = require("uuid");
var mid = require("../util/callbackMid");
module.exports = {
    urls: [
        "/oauth/github/callback"
    ],
    middlewares: {
        get: mid
    },
    routers: {
        get: function (req, res, scope) { return __awaiter(_this, void 0, void 0, function () {
            var evalidate, active, User, profile, found, email, created, success, user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log(scope.event);
                        evalidate = process.env.VIGOR_REGISTER_EMAIL_VALIDATE === "true";
                        active = false;
                        User = scope.models.User;
                        profile = req.user;
                        if (!profile) {
                            return [2, res.status(404).send("Not Found!")];
                        }
                        return [4, User.findOne({
                                githubUsername: profile.username
                            })];
                    case 1:
                        found = _a.sent();
                        if (!evalidate) {
                            active = true;
                        }
                        if (!!found) return [3, 3];
                        req.session.user = null;
                        email = profile.emails && profile.emails[0] && profile.emails[0].value;
                        return [4, User.create({
                                username: profile.username,
                                password: profile.accessToken,
                                email: email,
                                avatar: profile._json.avatar_url,
                                githubId: profile.id,
                                githubUsername: profile.username,
                                githubAccessToken: profile.accessToken,
                                active: active,
                                accessToken: uuid.v4()
                            })];
                    case 2:
                        created = _a.sent();
                        if (active) {
                            scope.event.send("message-user-register-success", {
                                email: email,
                                username: profile.username
                            });
                            req.session.user = created.toObject();
                        }
                        else {
                            scope.event.send("message-user-activate", created.email, created.accessToken, created);
                            success = "注册成功！<br/>";
                            success += "我们已给您的注册邮箱发送了一封邮件，请点击里面的链接来激活您的帐号。";
                            res.vRender({
                                success: success
                            }, "user/login");
                            return [2];
                        }
                        return [3, 5];
                    case 3: return [4, User.update({
                            id: found.id
                        }, {
                            githubId: profile.id,
                            githubUsername: profile.username,
                            githubAccessToken: profile.accessToken,
                            avatar: profile._json.avatar_url
                        })];
                    case 4:
                        user = _a.sent();
                        req.session.user = user[0].toObject();
                        _a.label = 5;
                    case 5:
                        if (req.session.url) {
                            return [2, res.redirect(req.session.url)];
                        }
                        return [2, res.redirect("/")];
                }
            });
        }); }
    }
};
